## opennebula 6.10.0.1

=== debian/changelog ===
opennebula (6.10.0.1-1) unstable; urgency=low

  * Build for 6.10.0.1-1 (Git revision 47a5d0fe)

 -- OpenNebula Team <contact@opennebula.io>  Fri, 21 Feb 2025 00:14:25 +0000
