=== debian/watch ===
version=3

opts=\
repacksuffix=+dfsg,\
dversionmangle=s{\+dfsg\d*}{},\
 https://github.com/OpenNebula/one/releases \
 .*/archive/release-(\d[\d\.]+)\.tar\.gz
